<template>
	<div class="cart">
		<table>
			<thead>
				<tr>
					<th>Item</th>
					<th>Price</th>
					<th>Quantity</th>
					<th>Import Duty</th>
					<th>Tax</th>
					<th>Subtotal</th>
				</tr>
			</thead>
			<tbody>
				<template v-for="(item, index) in localItems">
					<tr :key="index" :class="[!(index & 1) ? 'cart__even-row' : '']">
						<td>{{ item.name }}</td>
						<td>{{ formatAsCurrency(item.price) }}</td>
						<td>{{ item.qty }}</td>
						<td>{{ formatAsCurrency(item.importDuty) }}</td>
						<td>{{ formatAsCurrency(item.tax) }}</td>
						<td>{{ formatAsCurrency(item.subTotal) }}</td>
					</tr>
				</template>
			</tbody>
			<br />
			<div class="cart__totals-lines">
				Subtotal:&nbsp;{{ formatAsCurrency(subTotal) }}
			</div>
			<div class="cart__totals-lines">
				Tax:&nbsp;{{ formatAsCurrency(taxTotal) }}
			</div>
			<div class="cart__totals-lines">
				<strong>TOTAL:&nbsp;{{ formatAsCurrency(totalCharge) }}</strong>
			</div>
		</table>
		<div class="cart__return-btn-container">
			<input type="button" value="Clear Cart and Return to Home" @click="goToHome" class="global__button-pointer" />
		</div>
	</div>
</template>

<script>
    import { constants } from "@/constants.js"

    export default {
        name: 'Cart',
        props: {
            items: Array
        },
        data:() => ({
            localItems: Array,
        }),
        created() {
            this.localItems = this.items;
        },
        mounted () {
            this.addPropsToLocalItems();
        },
        computed: {
            subTotal() {
                let subTotal = 0;
                for (let i = 0; i < this.localItems.length; i++) {
                    subTotal += this.localItems[i].subTotal;
                }
                return subTotal;
            },
            taxTotal() {
                let taxTotal = 0;
                for (let i = 0; i < this.localItems.length; i++) {
                    taxTotal += this.localItems[i].tax;
                }
                return taxTotal;
            },
            totalCharge() {
                let total = this.subTotal + this.taxTotal;
                return total;
            }
        },
        methods: {
            addPropsToLocalItems(){
                this.localItems.forEach((item) => {
                    item.importDuty = this.setRowImportDuty(item);
                    item.tax = this.setRowTax(item);
                    item.subTotal = this.setRowSubtotal(item);
                })
            },
            setRowTax(item) {
                let salesTax = 0;

                if(!item.isTaxExempt) {
                    salesTax = this.roundTax(item.price * constants.SALES_TAX_RATE) * item.qty;
                }

                return salesTax;
            },
            setRowSubtotal(item) {
                return item.price * item.qty + item.tax + item.importDuty;
            },
            setRowImportDuty(item) {
                let importDuty = 0;

                if(item.isImported) {
                    importDuty = this.roundTax(item.price * constants.IMPORT_TAX_RATE) * item.qty;
                }

                return importDuty;
            },
            roundTax(tax) {
                let roundedTax = (Math.ceil(tax*20)/20).toFixed(1);
                return Number(roundedTax);
            },
            goToHome() {
                this.localItems = [];
                this.$emit("go-to-home");
            },
            formatAsCurrency(amount) {
                let formatedAmt = new Intl.NumberFormat("en-US", {
                    style: "currency",
                    currency: "USD",
                }).format(amount);

                return formatedAmt;
            }
        }
    };
</script>

<style scoped>
	.cart__even-row {
		background-color: #bbb;
	}

	.cart__totals-lines {
		padding: 5px;
	}

	.cart__return-btn-container {
		text-align: center;
		padding: 10px;
	}
</style>